(function(){
var _, _mid_ = "xge_device_js";
// utils
var log= function() {
	var a= Array.prototype.slice.call(arguments);
	a.unshift("["+_mid_+"]");
	console.log.apply(console, a);
}
var warn= log.w= function() {
	var a= Array.prototype.slice.call(arguments);
	a.unshift("["+_mid_+"]");
	console.warn.apply(console, a);
}
// private API
var _cb_= []; // system events
function event(e)
{
	log("event >>", e);
	if(!e.name) e.name= "system";
	for(var i in _cb_) _cb_[i](e);
}
function tocb(cb)
{ 
	if(typeof(cb)==="function") 
		return cb;
	if(LuaIsFunction(cb)) {
		// log("tocb:callback -> lua", cb);
		return LuaCreateFunction(cb);
	}
	warn("tocb:not a function",cb);
	return cb;
}

/*
applicationOpen
applicationStart
applicationSuspend
applicationExit
*/

// function setActive(v)
// {
// 	if(_.active==v) return;// log("APP:active:skip",v);
// 	log("system:active", v);
// 	_.active= v;
// 	event({ type:(v ? "applicationStart" : "applicationSuspend") });
// }
// function hidden2active()
// {
// 	var v= document.hidden || document.webkitHidden || document.msHidden || document.mozHidden || false;
// 	setActive(!v);
// }
// if(document.addEventListener) {
// 	var n= "visibilitychange", px= ["","webkit","moz","ms"];
// 	for(var i in px) document.addEventListener(px[i]+n,	hidden2active, false);
// }

// window.onready = window.onload = function() { 
// 	log("window:ready"); 
// 	event({ type:"applicationOpen", url:(window.location.pathname) }); 
// 	hidden2active();
// };

window.onbeforeunload = function() { 
	log("window:close"); 
	event({ type:"applicationExit" }); 
};
// window.addEventListener('load',function(){
// 	log("window:load"); 
// });

// public API
_= window[_mid_]=
{
	name : "xge.device",
	id : function()
	{
		var id= localStorage.getItem(_.name)||_.new();
		log("id",id);
		return id;
	},
	new : function()
	{
		var id= "html5:"+Date.now()+"-"+((0xFFFFFF*Math.random())>>0).toString(16);
		localStorage.setItem(_.name, id);
		return id;
	},
	
	listen : function(cb)
	{
		_cb_.push( tocb(cb) );
	},
	event : event,

	_storageDir 	: function(dir) { _._dir_= dir||""; },
	_storageFID 	: function(f) { return [_._dir_,f].join("."); },

	_storageRemove 	: function(f) { localStorage.removeItem( _._storageFID(f) ); },
	_storageLoad 	: function(f) { return localStorage.getItem( _._storageFID(f) ); },
	_storageSave 	: function(f,v) { localStorage.setItem( _._storageFID(f), v ); },

	// _storage : function(dir)
	// {
	// 	function id(f,d) { return (d ? [dir,d,f] : [dir,f]).join("."); };
	// 	return {
	// 		remove 	: function(f,d) { localStorage.removeItem( id(f,d) ); },
	// 		load 	: function(f,d) { return localStorage.getItem( id(f,d) ); },
	// 		save 	: function(v,f,d) { localStorage.setItem( id(f,d), v ); },
	// 	};
	// },
};
log("loaded");
})();

